//+------------------------------------------------------------------+
//|                                           Stochastic Rainbow.mq4 |
//|                                  Copyright  2011, Andrew Sumner |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Andrew Sumner"
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 DarkBlue
#property indicator_color2 Blue
#property indicator_color3 DarkGreen
#property indicator_color4 SeaGreen
#property indicator_color5 FireBrick
#property indicator_color6 Red
#property indicator_color7 OrangeRed
#property indicator_color8 Orange

#property indicator_level1 80
#property indicator_level2 20

double Stoch0[];
double Stoch1[];
double Stoch2[];
double Stoch3[];
double Stoch4[];
double Stoch5[];
double Stoch6[];
double Stoch7[];

extern int StochPeriod = 1;
extern int KPeriod = 3;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
    IndicatorShortName("StochRainbow");
    IndicatorBuffers(8);
    SetIndexBuffer(0, Stoch0);
    SetIndexBuffer(1, Stoch1);
    SetIndexBuffer(2, Stoch2);
    SetIndexBuffer(3, Stoch3);
    SetIndexBuffer(4, Stoch4);
    SetIndexBuffer(5, Stoch5);
    SetIndexBuffer(6, Stoch6);
    SetIndexBuffer(7, Stoch7);
    
    SetIndexStyle(0, DRAW_LINE);
    SetIndexStyle(1, DRAW_LINE);
    SetIndexStyle(2, DRAW_LINE);
    SetIndexStyle(3, DRAW_LINE);
    SetIndexStyle(4, DRAW_LINE);
    SetIndexStyle(5, DRAW_LINE);
    SetIndexStyle(6, DRAW_LINE);
    SetIndexStyle(7, DRAW_LINE);
    
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
    int index = 0;
    int counted_bars=IndicatorCounted();

    int limit = Bars - counted_bars;
    
    for (index=0; index<limit; index++)
    {
      Stoch0[index] = iStochastic( NULL, 0, 3 * KPeriod, 3 * StochPeriod, 3, MODE_SMA, 0, MODE_SIGNAL, index );
      Stoch1[index] = iStochastic( NULL, 0, 4 * KPeriod, 4 * StochPeriod, 3, MODE_SMA, 0, MODE_SIGNAL, index );
      Stoch2[index] = iStochastic( NULL, 0, 5 * KPeriod, 5 * StochPeriod, 3, MODE_SMA, 0, MODE_SIGNAL, index );
      Stoch3[index] = iStochastic( NULL, 0, 6 * KPeriod, 6 * StochPeriod, 3, MODE_SMA, 0, MODE_SIGNAL, index );
      Stoch4[index] = iStochastic( NULL, 0, 7 * KPeriod, 7 * StochPeriod, 3, MODE_SMA, 0, MODE_SIGNAL, index );
      Stoch5[index] = iStochastic( NULL, 0, 8 * KPeriod, 8 * StochPeriod, 3, MODE_SMA, 0, MODE_SIGNAL, index );
      Stoch6[index] = iStochastic( NULL, 0, 9 * KPeriod, 9 * StochPeriod, 3, MODE_SMA, 0, MODE_SIGNAL, index );
      Stoch7[index] = iStochastic( NULL, 0, 10 * KPeriod, 10 * StochPeriod, 3, MODE_SMA, 0, MODE_SIGNAL, index );
    }
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+


